<?php include_once $_SERVER['DOCUMENT_ROOT'].'/belarusweb/belarusweb_files/php/site_parts/part_before_example.php';



class my_class{
	public $var_1=5;		      //К доступным свойствам перегрузка не применяется
	
	private $private_var_1=10; //В отношении закрытых свойств методы перегрузки 
	private $private_var_2;	   //вызываются только при доступе вне класса, где 
									   //они недоступны обычными способами
	
	//Метод автоматически вызывается в случае обращения к недоступным свойствам
	public function __set($name, $value){ 
     	$this->$name=$value;    //Устанавливаем значение недоступного свойства
	}
	
	//Метод возвращает значение недоступного свойства, если оно установлено,  
	//или выводит сообщение, если такого свойства нет или оно не инициализировано
	public function __get($name){
		//Если переменная установлена значением отличным от null
		if(isset($this->$name)){
			return  $this->$name;//возвращаем значение недоступного свойства
		}else{
			echo "Свойство {$name} отсутствует или не определено в данном классе.";
		}
	}
	
	public function __isset($name){
      return isset($this->$name); //возвращаем результат вызова функции isset(),  
	}										 //вызванной для недоступного свойства
	
	public function __unset($name){
      unset($this->$name);  		 //удаляем недоступное свойство 
   }										 
}

$obj_1=new my_class(); 	 		//Создаем объект класса my_class
			 		 
echo $obj_1->private_var_1.'<br>';  //Выведет 10, что возможно благодаря определенному 
										//в классе методу перегрузки __get()
$obj_1->private_var_1=20; 		//Изменяем значение закрытого свойства вне класса,
										//что возможно благодаря методу перегрузки __set()
echo $obj_1->private_var_1.'<br>';	//Выведет 20

echo isset($obj_1->private_var_1).'<br>'; //Выведет '1', т.е. true
unset($obj_1->private_var_1); //Удаляем закрытое свойство вне класса, что стало
										//возможным благодаря методу перегрузки __unset()
echo isset($obj_1->private_var_1).'<br>'; //Выведет '', т.е. false - свойство удалено

echo $obj_1->private_var_2.'<br>';	//Метод перегрузки __get() выведет сообщение	
$obj_1->private_var_2=5; 		//Устанавливаем значение закрытого св-ва вне класса
echo $obj_1->private_var_2.'<br>';	//Выведет 5					 
					
echo $obj_1->private_var_3;	//Метод перегрузки __get() выведет сообщение												 




include_once $_SERVER['DOCUMENT_ROOT'].'/belarusweb/belarusweb_files/php/site_parts/part_after_example.php'?> 

