<?php
namespace current_name_space{    //Объявили пространство имен
	const my_const = 1;    //Объявили константу в текущем пространстве имен 
	
	//Обратимся к константе из текущего пространства имен
	
	//PHP дополнит неполное имя до полного current_name_space\my_const 
	echo my_const.'<br>';  //выведет 1
	
	//PHP использует полное имя current_name_space\my_const 
	echo \current_name_space\my_const.'<br>'; //выведет 1
	
	//PHP преобразует в current_name_space\current_name_space\my_const 
	//echo current_name_space\my_const.'<br>';//выведет ошибку
}

namespace current_name_space\myStore{ //Объявили подпространство имен
	const my_const = 2;    //Объявили константу в current_name_space\myStore
	
	class my_class{        //Объявили класс в current_name_space\myStore
		function my_method(){
		echo my_const.'<br>';
		}
	}
	
	$a=new my_class;       //Создали объект класса
	
	//Обратимся к константе и методу из текущего пространства имен 
	
	//PHP дополнит неполное имя до полного current_name_space\myStore\my_const 
	echo my_const.'<br>';  //выведет 2
	//PHP преобразует в полное имя current_name_space\myStore\my_const 
	echo \current_name_space\myStore\my_const.'<br>';//выведет 2
	
	//PHP просто вызовет метод, т.к. переменные не зависят от пространства имен	
	$a->my_method();       //выведет 2
	//вызовет ошибку, т.к. к переменным пространства имен	не применяются
	//\current_name_space\myStore\a->my_method();
}

namespace{
	//Выведет ошибку, т.к. в глобальном пространстве my_const не определена
	//echo my_const.'<br>';
	
	//PHP обратится к current_name_space\my_const 
	echo current_name_space\my_const.'<br>';//выведет 1
	//PHP опять обратится к current_name_space\my_const 
	echo \current_name_space\my_const.'<br>';//выведет 1
	
	//PHP обратится к current_name_space\myStore\my_const 
	echo current_name_space\myStore\my_const.'<br>';//выведет 2
	//PHP опять обратится к current_name_space\myStore\my_const 
	echo \current_name_space\myStore\my_const.'<br>';//выведет 2
	
	//PHP просто вызовет метод, т.к. переменные не зависят от пространства имен
	//А вот если бы метод был объявлен статическим, тогда к нему можно было бы 
	//обратиться как current_name_space\myStore\my_class::my_method()
	$a->my_method();//выведет 2
}
?>