<?php
namespace{
	//Объявляем константы в глобальном пространстве
	const my_const = 'global constant';
	const my_const_2 = 'global constant_2';
	
	//Объявляем функцию в глобальном пространстве
	function global_function(){
		echo 'global function'.'<br>';
	}
	
	//Объявляем класс в глобальном пространстве
	class global_class{
		static function global_method(){
			echo 'global method'.'<br>';
		}
	}
		
	echo my_const.'<br>';                    //Выведет 'global constant'
	//А вот здесь будет ошибка, т.к. константа еще не определена
	//echo current_name_space\my_const.'<br>'; 
	global_function();                       //Выведет 'global function'
	current_name_space\current_function();   //Выведет 'current function'	
	global_class::global_method();           //Выведет 'global method'
}


namespace current_name_space{               //Объявили пространство имен
	//Объявляем константу в текущем пространстве имен 
	const my_const = 'current_constant';    
		
	//PHP обратится к current_name_space\my_const 
	echo my_const.'<br>';                    //Выведет 'current_constant'
	//PHP использует абсолютное имя \my_const 
	echo \my_const.'<br>';                   //Выведет 'global constant'
	//Здесь PHP не найдет константы, поэтому перейдет к глобальному пространству
	echo my_const_2.'<br>';                  //Выведет 'global constant_2'
	
	
	function current_function(){
		echo 'current function'.'<br>';
	}
		
	//Вызываем функцию current_name_space\current_function()
	current_function();                      //Выведет 'current function'	
	//Вызываем глобальную функцию \global_function()
	\global_function();                      //Выведет 'global function'
	
	//Имена классов всегда преобразуются к текущему имени пространства имен
	//global_class::global_method();         //Выведет ошибку
	//А вот здесь все правильно, PHP воспользуется абсолютным адресом
	\global_class::global_method();          //Выведет 'global method'
}
?>