<?php
echo '-------- fgets() -------- <br><br>';

//Используем функцию fopen() и откроем файл в режиме бинарного чтения (по байтам)
$handle=fopen('test_4.txt', 'rb');

//Функция feof() проверяет достигнут ли конец файла и возвращает true, если указатель 
//файла указывает на конец файла, иначе возвращает false. В качестве аргумента 
//принимает дискриптор файла, поэтому для удобства мы его сохранили в переменной 
//Цикл будет закончен при достижении конца файла
while(!feof($handle)){
//fgets() считывает строку из файла, аргументом служит дескриптор файла. Также 
//посмотрите fgetss(), которая считывает строку, но при этом отбрасывает html-теги 
echo fgets($handle).'<br>'; //Выведет все три строки файла test.txt
}
//После завершения работы с файлом не забываем закрыть его
fclose($handle);
echo '<br><br>'; 


echo '-------- fgetc() -------- <br><br>';

//Теперь продемонстрируем посимвольное чтение открытого файла
//Используем функцию fopen() и откроем файл в режиме бинарного чтения
$handle=fopen('test_4.txt', 'rb');

//Здесь мы в качестве примера изменили условие, присвоив переменной дескриптор файла 
//fgetc() считывает по одному символу и возвращает false при достижении конца файла 
$my_text='';
while($fc=fgetc($handle)){
	$my_text.=$fc; //За цикл все символы файла будут занесены в переменную
}
//Т.к. переносы строк в HTML преобразуются в пробелы, то для вывода в браузер мы
//используем nl2br(), которая вставляет '<br>' перед символами переноса строк
echo nl2br($my_text); //Также выведет все три строки файла test.txt

//После завершения работы с файлом не забываем закрыть его
fclose($handle);
echo '<br><br>'; 


echo '-------- fread() -------- <br><br>';

//Для чтения заданного объема файла в бинарно-безопасном режиме используется
//функция fread(), которая возвращает прочтенную строку или false в случае ошибки 

//Используем функцию fopen() и откроем файл в режиме бинарного чтения (как всегда)
$handle=fopen('test_4.txt', 'rb');

//Аргументами являются файловый дескриптор и требуемый размер (мы считываем весь файл) 
$my_text=fread($handle, filesize('test_4.txt'));

//Т.к. переносы строк не работают в HTML, то для правильного вывода в браузер можно
//опять использовать nl2br(), которая вставляет '<br>' перед символами переноса строк
//echo nl2br($my_text); //Также выведет все три строки файла test.txt
//Но мы в качестве примера используем str_replace("". PHP_EOL ."", "<br>", $my_text)
echo str_replace("". PHP_EOL ."", "<br>", $my_text);
//После завершения работы с файлом не забываем закрыть его
fclose($handle);
echo '<br><br>'; 


echo '-------- fseek() -------- <br><br>';

//Для смещения файлового указателя в нужную позицию (указывается в байтах) используется 
//fseek(), которая возвращает 0 в случае успеха и -1 при возникновении ошибки 
//Также смотрите ftell(), которая сообщает текущую позицию чтения/записи файла и 
//rewind(), которая сбрасывает курсор файлового указателя в начало файла

//Используем функцию fopen() и откроем файл в режиме бинарного чтения 
$handle=fopen('test_4.txt', 'rb');

//Начнем считывать файл с середины, для этого сместим указатель в середину файла
fseek($handle, filesize('test_4.txt')/2);
//Поскольку нужно считать половину файла, размер чтения также будет равен половине
$my_text=fread($handle, filesize('test_4.txt')/2);

//Выведет лишь часть файла, где первым символом будет 'кракозябра' из-за того, что 
//указатель попал между байтами, отвечающими за многобайтовый символ
echo nl2br($my_text); 

//После завершения работы с файлом не забываем закрыть его
fclose($handle);
echo '<br><br>'; 


echo '-------- file_get_contents() -------- <br><br>';

//Если файл нужно просто прочитать, то это можно сделать за одну операцию при помощи
//file_get_contents(), которая считывает содержимое файла в строку и возвращает ее в 
//случае успеха, иначе - false. При этом не нужно открывать файл при помощи fopen(). 
//Также см. file(), которая читает содержимое файла и помещает его в массив
echo nl2br(file_get_contents('test_4.txt'));//Опять получим 3 строки файла
echo '<br><br>'; 
?>