<?php
echo '-------- fwrite()  -------- <br><br>';

//Используем функцию fopen() и откроем файл в бинарном режиме записи и чтения  
$handle=fopen('test_4.txt', 'a+b'); 

//fwrite() (или же fputs()) - записывает строку указанной длины в файл
//Возвращает количество записанных байт или false в случае ошибки
//Т.к. в режиме 'a+b' указатель помещается в конец файла, то данные будут не 
//перезаписаны, а также добавлены в конец файла 
fwrite($handle, PHP_EOL .'Еще строка текста.'); 

//Чтобы прочитать измененный файл, вернем указатель в начало файла
rewind($handle);
//Выведем обновленное содержимое файла на экран 
echo nl2br(fread($handle, 10000));

//После завершения работы с файлом не забываем закрыть его
fclose($handle);
echo '<br><br>'; 


echo '-------- file_put_contents() -------- <br><br>';

//file_put_contents() - записывает строку в файл. При этом открывать файл не нужно. 
//Записываемые данные, которые могут быть строкой, массивом или ресурсом, передаются
//вторым аргументом. По умолчанию файл будет перезаписан, однако в качестве 3-го 
//аргумента можно передать дополнительный флаг FILE_APPEND (данные записываются в 
//конец файла). Одновременно можно указать FILE_USE_INCLUDE_PATH - файл будет
//дополнительно искаться в подключаемых директориях, и LOCK_EX - файл будет 
//блокирован на время записи. Функция возвращает количество записанных байт 
//или false в случае ошибки. В примере указанная строка будет дописана в конец файла, 
//а сам файл на время записи будет заблокирован
file_put_contents('test_4.txt', PHP_EOL .'Еще строка текста.', FILE_APPEND|LOCK_EX); 

//Выведем обновленное содержимое на экран
echo nl2br(file_get_contents('test_4.txt'));
echo '<br><br>';


echo '-------- flock() -------- <br><br>';

//flock () - блокирует файл, не позволяя другим пользователям читать файл или 
//записывать данные в него. Для этого в качестве второго аргумента используются
//флаги LOCK_SH - разделяемая блокировка (чтение), LOCK_EX - эксклюзивная 
//блокировка (запись), LOCK_UN - снятие блокировки (разделяемой или эксклюзивной)
//Возвращает true в случае успешного завершения, иначе - false 

//Откроем файл в режиме чтения и записи
$handle=fopen('test_4.txt', 'a+b'); 

//Если файл удачно заблокируется, то начнем перезапись
if(flock($handle, LOCK_EX)){ 
	//Функция ftruncate() урезает файл до указанной длинны (см. справочник)
	ftruncate($handle, 0); 
	//Записываем данные
	fwrite($handle, PHP_EOL .'Новый текст.');
	//Отпираем файл
	flock($handle, LOCK_UN); 
}else{
	echo "Попробуйте обратиться к файлу позже!";
}

//Вернем указатель в начало файла
rewind($handle);
//Выведем измененное содержимое файла на экран 
echo nl2br(fread($handle, 10000));
//После завершения работы с файлом не забываем закрыть его
fclose($handle);
?>